#!/usr/bin/python
##############################################################################
#
# Copyright (c) 2002, 2006 Nexedi SARL and Contributors. All Rights Reserved.
#                    Bartlomiej Gorny <bartek@erp5.pl>
#                    Jacek Medrzycki <jacek@erp5.pl>
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

import sys

import config
from logger import Log

sys.path.insert(0, config.uno_path)
import uno

import worker

class WorkerFactory(object):

  def __init__(self):
    self.ctxLocal = uno.getComponentContext()
    self.smgrLocal = self.ctxLocal.ServiceManager
    self.resolver = self.smgrLocal.createInstanceWithContext("com.sun.star.bridge.UnoUrlResolver", self.ctxLocal)

  def build(self, pool, i):
    """
       Create a context, bind it to next instance of OO using calculated port number.
    """
    Log.warning('[factory] building worker for %d' % i)
    instance_port = config.pool_port_range_start + i
    print "build - instance port",instance_port
    ctx = self.resolver.resolve("uno:socket,host=%s,port=%d;urp;StarOffice.ComponentContext" % (config.pool_host, instance_port))
    smgr = ctx.ServiceManager
    desktop = smgr.createInstanceWithContext("com.sun.star.frame.Desktop", ctx)
    w = worker.Worker(i, desktop, pool)
    Log.info('[factory] worker for %d created' % i)
    return w

builder = WorkerFactory()

# vim: shiftwidth=2
