#!/usr/bin/python
##############################################################################
#
# Copyright (c) 2002, 2006 Nexedi SARL and Contributors. All Rights Reserved.
#                    Bartlomiej Gorny <bartek@erp5.pl>
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

import threading
import time

import config
from oood_common import asciify


class WorkerException(Exception):pass
class IllegalMimeType(WorkerException):pass
class IllegalFormat(WorkerException):pass
class IllegalMetaAttribute(WorkerException):pass
class NotLoaded(WorkerException):pass
class NotFound(WorkerException):pass
class GenerationFailed(WorkerException):pass

class ServerException(Exception):pass
class WorkerNotAvailable(ServerException):pass
class SetMetaFailed(ServerException):pass


sv = ['INFO','WARNING','ERROR','FATAL']

max_sv_size = 0
for s in sv:
  if len(s) > max_sv_size:
    max_sv_size = len(s)

loglock = threading.Lock()

def log(msg, severity=0):
  loglock.acquire()
  f = open(config.log_file, 'a')
  thname = threading.currentThread().getName()
  s = '%s [%s]: %*s: %s\r\n' % (time.strftime('%Y-%m-%d %H:%M:%S'), thname, max_sv_size, sv[severity], msg)
  f.write(s)
  f.close()
  loglock.release()

# vim: shiftwidth=2
