#!/usr/bin/python
##############################################################################
#
# Copyright (c) 2002, 2006 Nexedi SARL and Contributors. All Rights Reserved.
#                    Bartlomiej Gorny <bartek@erp5.pl>
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################


import logging
import sys
import threading
import traceback
import config
import lib


class mylog(object):

    funcs = ('debug', 'info', 'warning', 'error', 'critical', 'exception')

    def __init__(self):
	self.logger = logging.getLogger('oood')
	handler = logging.FileHandler(config.log_file)
	formatter = logging.Formatter('%(asctime)s %(levelname)-8s %(message)s',
                                      '%Y/%m/%d %H:%M:%S')
	handler.setFormatter(formatter)
	self.logger.addHandler(handler) 
	self.logger.setLevel(config.log_level)

        def mkFunc(f):
            logfunc = getattr(self.logger, f)
            def _func(msg, *a, **kw):
                thread_name = threading.currentThread().getName()
                msg = '<%s> %s' %(thread_name, msg)
                logfunc(msg, *a, **kw)
            return _func
        for f in self.funcs:
            setattr(self, f, mkFunc(f))

    def logException(self, e, tb=None):
      if tb is None:
        tb = sys.exc_info()[2]
      try:
        Log.error(e.__class__.__name__ + ': ' + str(e))
      except UnicodeEncodeError:
        Log.error(lib.asciify(e.args[0]))
      Log.error(''.join(traceback.format_tb(tb)))

Log = mylog()


if __name__=='__main__':
    Log.warning('bleble')
    Log.critical('iiiiiii')
