/*
#############################################################################

 Copyright (c) 2002, 2006 Nexedi SARL and Contributors. All Rights Reserved.
                    Mikolaj Antoszkiewicz <mikolaj@erp5.pl>

 WARNING: This program as such is intended to be used by professional
 programmers who take the whole responsability of assessing all potential
 consequences resulting from its eventual inadequacies and bugs
 End users who are looking for a ready-to-use solution with commercial
 garantees and support are strongly adviced to contract a Free Software
 Service Company

 This program is Free Software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#############################################################################
*/

#include "XmlRpc.h" // xmlrpc++ library ver.0.7 - http://xmlrpcpp.sourceforge.net/
#include "Base64.h" // Base64 class from C++ Sockets Library - http://www.alhem.net/Sockets/index.html
#include <iostream>

using namespace XmlRpc;
using namespace std;

int main(int argc, char* argv[]) {

    FILE* infile = fopen("test2.odt","r");
    std::string data;

    Base64 tmp_base;
    tmp_base.encode(infile, data, false);

    XmlRpcClient client("localhost", 8008);

    XmlRpcValue result;
    XmlRpcValue Args;
    Args["data"] = data.c_str();
    Args["extension"] = "pdf";
    
    client.execute("generate", Args, result);
   
    std::cout << "Oood result code: " << result[0] << std::endl;
    
    std::string dec_data;
    tmp_base.decode(result[1]["data"], dec_data);
    
    FILE* outfile = fopen("test.pdf","wb");
    const char* outbuf = dec_data.c_str();
    fwrite(outbuf, sizeof(dec_data[0]), dec_data.size()-1, outfile);
    fclose(outfile);
    return 0;
} 
